----------------------------------------------------------------------------------
-- ECE 3401 Spring 2018: Lab 1's testbench
-- University of Connecticut
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
 
ENTITY lab1tests18 IS
END lab1tests18;
 
ARCHITECTURE behavior OF lab1tests18 IS 
 
    COMPONENT lab1
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         en : IN  std_logic;
         sel : IN  unsigned(2 downto 0);
         A : IN  unsigned(31 downto 0);
         Output : OUT  unsigned(63 downto 0);
         overflow : OUT  std_logic
        );
    END COMPONENT;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
   
   --Inputs 
   signal clk, reset, en : std_logic := '0';
   signal sel            : unsigned(2 downto 0) := (others => '0');
   signal A              : unsigned(31 downto 0) := (others => '0');

   --Outputs
   signal Output   : unsigned(63 downto 0);
   signal overflow : std_logic;
 
BEGIN
   
   -- Instantiate the Unit Under Test (UUT)
   uut: lab1 PORT MAP (
          clk => clk,
          reset => reset,
          en => en,
          sel => sel,
          A => A,
          Output => Output,
          overflow => overflow);

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;

   -- Stimulus process
   stim_proc: process
   begin		
      wait for 10 ns;	

      -- insert stimulus here 


      wait;
   end process;

END;
